package org.xquark.xquery.parser.primitivefunctions.fnfunctions;

import java.util.ArrayList;

import org.xquark.xquery.parser.*;
import org.xquark.xquery.parser.util.Constants;
import org.xquark.xquery.typing.TypeException;

public class FunctionNAMESPACE_URI_FROM_QNAME extends PrimitiveFunctionCall {

    private static final String RCSRevision = "$Revision: 1.4 $";

    private static final String RCSName = "$Name:  $";

    // #############################################################################
    // VISITOR STUFF
    // #############################################################################

    public void accept(ParserVisitor visitor) throws XQueryException {
        visitor.visit(this);
    }

    // #############################################################################
    // CONSTRUCTOR STUFF
    // #############################################################################

    public FunctionNAMESPACE_URI_FROM_QNAME(ArrayList args, XQueryModule parentModule) throws TypeException, XQueryException {
        super(parentModule, new QName(Constants.FNURI, Constants.FN, "namespace-uri-from-QName", null, null), args);
        if (parentModule != null && parentModule.getStaticContext().getTypeVisitor() != null)
            accept(parentModule.getStaticContext().getTypeVisitor());
    }

    // this function should be called with one argument
    public void setArguments(ArrayList arguments) throws XQueryException {
        if (arguments != null && arguments.size() > 1)
            throw new XQueryException("Function namespace-uri-from-QName should have at most one argument");
        super.setArguments(arguments);
    }

}
