package org.xquark.xquery.parser.primitivefunctions.xqfunctions;

import java.util.ArrayList;

import org.xquark.xquery.parser.*;
import org.xquark.xquery.parser.util.Constants;
import org.xquark.xquery.typing.TypeException;

public class FunctionXML_FRAGMENT extends PrimitiveFunctionCall {

    // #############################################################################
    // VISITOR STUFF
    // #############################################################################

    public void accept(ParserVisitor visitor) throws XQueryException {
        visitor.visit(this);
    }

    // #############################################################################
    // CONSTRUCTOR STUFF
    // #############################################################################
    public FunctionXML_FRAGMENT(ArrayList args, XQueryModule parentModule) throws TypeException, XQueryException {
        super(parentModule, new QName(Constants.XQURI, Constants.XQ, "xml-fragment", null, null), args);
        if (parentModule != null && parentModule.getStaticContext().getTypeVisitor() != null)
            accept(parentModule.getStaticContext().getTypeVisitor());
    }

    public void setArguments(ArrayList arguments) throws XQueryException {
        if (arguments == null || arguments.size() != 2)
            throw new XQueryException("Function xml-fragment should have two arguments");
        super.setArguments(arguments);
    }

}
