package org.xquark.xquery.parser.primitivefunctions.xqjutilfunctions;

import java.util.ArrayList;

import org.xquark.xquery.parser.ParserVisitor;
import org.xquark.xquery.parser.PrimitiveFunctionCall;
import org.xquark.xquery.parser.QName;
import org.xquark.xquery.parser.XQueryException;
import org.xquark.xquery.parser.XQueryModule;
import org.xquark.xquery.parser.util.Constants;
import org.xquark.xquery.typing.TypeException;

public class FunctionAVAILABLE_STANDARD_FUNCTIONS extends PrimitiveFunctionCall{
    
    // #############################################################################
    // VISITOR STUFF
    // #############################################################################
    
    public void accept(ParserVisitor visitor) throws XQueryException {
        visitor.visit(this);
    }
    
    // #############################################################################
    // CONSTRUCTOR STUFF
    // #############################################################################
    // xqj-util:available-standard-functions() as element(xqjm:function)*
    // equivalent to -> xqj-util:metadata()/xqjm:metadata/xqjm:functions/xqjm:function[@namespaceURI != "http://www.w3.org/2004/03/xpath-functions"]
    public FunctionAVAILABLE_STANDARD_FUNCTIONS(ArrayList args, XQueryModule parentModule) throws TypeException, XQueryException {
        super(parentModule, new QName(Constants.XQJ_UTILURI, Constants.XQJ_UTIL,"available-standard-functions",null,null),args);
        //setQType(new QTypeDocument(new QTypeElement(new QName(null,"xqjm","metadata",parentModule,null),)))
        /*
        if (parentModule != null && parentModule.getStaticContext().getTypeVisitor() != null)
            accept(parentModule.getStaticContext().getTypeVisitor());
        */
    }

    public void setArguments(ArrayList arguments) throws XQueryException {
        if (arguments != null) throw new XQueryException("Function available-standard-functions does not accept any argument");
        super.setArguments(arguments);
    }

}
